package com.adaptionsoft.games.trivia.runner

import com.adaptionsoft.games.trivia.runner.FileUtils.Companion.fileLines
import com.adaptionsoft.games.uglytrivia.actions.*
import com.adaptionsoft.games.uglytrivia.core.GameBoard
import com.adaptionsoft.games.uglytrivia.core.Rules
import com.adaptionsoft.games.uglytrivia.core.Turn
import com.adaptionsoft.games.uglytrivia.infrastructure.*
import org.junit.jupiter.api.Assertions.assertLinesMatch
import org.junit.jupiter.api.Test
import java.io.ByteArrayOutputStream
import java.io.PrintStream

internal class GameRunnerShould {
    @Test
    fun `work as always`() {
        val stream = ByteArrayOutputStream()
        val printStream = PrintStream(stream)
        val eventStream = StreamEventWriter(printStream)
        val turn = Turn()
        val gameboard = GameBoard(AutogeneratedQuestions(), InMemoryPlayerPositions())
        val rules = Rules(InMemoryPenaltyBox())

        val addPlayer = AddPlayer(gameboard, turn)
        val correctAnswer = CorrectAnswer(turn, rules)
        val wrongAnswer = WrongAnswer(turn, rules)
        val roll = Roll(gameboard, rules, turn)

        correctAnswer.correctAnswerEvent += eventStream::correctAnswer
        wrongAnswer.wrongAnswerEvent += eventStream::wrongAnswer
        gameboard.playerMovementEvent += eventStream::playerLocationChange
        gameboard.categoryChangeEvent += eventStream::categoryChange
        gameboard.playerAddedEvent += eventStream::playerAdded
        roll.turnStartEvent += eventStream::turnStart
        roll.askQuestion += eventStream::askQuestion
        rules.gettingOutPenaltyBox += eventStream::gettingOutPenaltyBox
        rules.sentToPenaltyBox += eventStream::sentToPenaltyBox
        rules.notGettingOutPenaltyBox += eventStream::notGettingOutPenaltyBox

        val gameRunner = GameRunner(
            addPlayer,
            correctAnswer,
            wrongAnswer,
            roll,
            DidSomeoneWon(turn)
        )
        gameRunner.play(RandomSequenceFile.initialize())

        assertLinesMatch(
            stream.toByteArray().inputStream().reader().readLines(),
            fileLines("result.txt")
        )
    }
}